<template>
	<f7-page name="freebiesdetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="freebie != null" class="show-small-title">Barang Loak</f7-nav-title>
            <f7-nav-title-large v-if="freebie != null">{{ freebie.title }}</f7-nav-title-large>
            <f7-nav-right>
                <f7-link v-if="freebie != null" :href="`/freebies/view/${freebie.id}/comments/`">
                    <f7-icon ios="f7:chat" aurora="f7:chat" md="f7:chat" class="icon f7-icons">
					    <f7-badge color="red">{{ freebie.total_comment.kformat() }}</f7-badge>					
				    </f7-icon>
                </f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-block v-if="freebie != null">
            <f7-swiper v-if="freebie.medias.length > 0" pagination :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide class="freebie-has-browser" v-for="item in freebie.medias" v-bind:key="item.id">
                    <span class="image-thumb" :style="`background-image: url(${item.url.medium});`"></span>
                </f7-swiper-slide>
            </f7-swiper>
            <f7-swiper v-else :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide>
                    <span class="image-thumb" :style="`background-image:url(${require('../assets/no-photo.jpg')})`"></span>
                </f7-swiper-slide>
            </f7-swiper>            
        </f7-block>
        <f7-block v-if="freebie != null" class="product-detail">
            <h3 class="no-margin-bottom">{{ freebie.title }}</h3>
            <small class="display-block margin-small-bottom">Terakhir Diperbaharui: {{ dateFormat(freebie.updated, 'DD MMMM YYYY') }}</small>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;">{{ freebie.description }}</span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="person" size="18px" color="green"></f7-icon>  {{ freebie.author.profile.fullname }}</span>
            <f7-list style="border-bottom:1px dashed #ddd;" class="no-margin" no-hairlines>
                <f7-list-item>
                    <div class="item-title"><f7-icon f7="placemark" size="20px" color="orange"></f7-icon> {{ currentLocation != null ? 'Lokasi pengambilan ' + distance(currentLocation.latitude, currentLocation.longitude, freebie.latitude, freebie.longitude) : 'Lihat lokasi' }}</div>
                    <f7-toggle 
                        color="blue"
                        value="1"
                        :checked="showMap"
                        @toggleChange="handleShowMap($event)"></f7-toggle>
                </f7-list-item>
            </f7-list>
            <GmapMap 
                id="map"
                v-if="showMap == true" 
                ref="mapRef"
                :options="{
                    zoomControl: true,
                    mapTypeControl: false,
                    scaleControl: false,
                    streetViewControl: false,
                    rotateControl: false,
                    fullscreenControl: true,
                    disableDefaultUi: false,
                    scrollwheel: false
                }"
                :zoom="map.zoom"
                :center="map.center">
                <GmapMarker :position="map.center" :clickable="false" :draggable="false"></GmapMarker>
            </GmapMap> 
        </f7-block>        
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { gmapApi } from 'vue2-google-maps';
import { dateFormat, distance } from '../js/utils';
export default {
    name: 'FreebiesDetail',
    data(){
        return {
            photoBrowser: null,
            showMap: false,
            map: {
				zoom: 14,
				center: {
					lat: -2.9760735,
					lng: 104.77543070000002
				}
			},
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('freebies', [
			'freebie'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        google: gmapApi,
        distance,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('freebies/viewFreebie', {
                id: self.$f7route.params.id,
                only: 'id,title,slug,description,latitude,longitude,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media,total_comment'
            }).then(() => {
                app.preloader.hide();
                self.phottoBrowserInit();

                if(self.freebie.latitude != null && self.freebie.longitude != null){
                    self.showMap = true;

                    self.map.zoom = 18;
                    self.map.center.lat = self.freebie.latitude;
                    self.map.center.lng = self.freebie.longitude;
                }

            });
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('freebies/resetFreebie');
            self.photoBrowser.destroy();
        },
        handleShowMap(value){
			const self = this;
            self.showMap = value;
        },
        phottoBrowserInit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            if(self.freebie.medias != null){
                let medias = self.freebie.medias.map((x) => x.url.original);
                self.photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                });

                $$(document).on('click', '.freebie-has-browser', function(){
                    self.photoBrowser.open();
                });
            }
        }
    }
}
</script>
